redi::basic_rpstream< CharT, Traits >(3)

NAME
redi::basic_rpstream< CharT, Traits > - Class template for Restricted PStreams.

SYNOPSIS

#include <pstream.h>

Inherits basic_ostream< CharT, Traits >, basic_istream< CharT, Traits >, redi::pstream_common< CharT, Traits >, and redi::pstreams.

  Public Types

typedef pbase_type::pmode pmode
Type used to specify how to connect to the process.
typedef pbase_type::argv_type argv_type
Type used to hold the arguments for a command.
typedef int fd_type
Type used for file descriptors.

  Public Member Functions

basic_rpstream ()
Default constructor, creates an uninitialised stream.
basic_rpstream (const std::string &cmd, pmode mode=pstdout|pstdin)
Constructor that initialises the stream by starting a process.
basic_rpstream (const std::string &file, const argv_type &argv, pmode mode=pstdout|pstdin)
Constructor that initialises the stream by starting a process.
basic_rpstream (const argv_type &argv, pmode mode=pstdout|pstdin)
Constructor that initialises the stream by starting a process.
~basic_rpstream ()
Destructor.
void open (const std::string &cmd, pmode mode=pstdout|pstdin)
Start a process.
void open (const std::string &file, const argv_type &argv, pmode mode=pstdout|pstdin)
Start a process.
istream_type & out ()
Obtain a reference to the istream that reads the process' stdout.
istream_type & err ()
Obtain a reference to the istream that reads the process' stderr.

  Static Public Attributes

static const pmode pstdin = std::ios_base::out
Write to stdin.
static const pmode pstdout = std::ios_base::in
Read from stdout.
static const pmode pstderr = std::ios_base::app
Read from stderr.
static const pmode newpg = std::ios_base::trunc
Create a new process group for the child process.

  Protected Types

enum { bufsz = 32 }
enum { pbsz = 2 }

  Private Types

typedef basic_pstreambuf< CharT, Traits > streambuf_type
enum { bufsz = 32 }
enum { pbsz = 2 }
typedef int fd_type
Type used for file descriptors.

  Private Member Functions

void do_open (const std::string &cmd, pmode mode)
Start a process.
void do_open (const std::string &file, const argv_type &argv, pmode mode)
Start a process.
void close ()
Close the pipe.
bool is_open () const
Report whether the stream's buffer has been initialised.
const std::string & command () const
Return the command used to initialise the stream.
streambuf_type * rdbuf () const
Return a pointer to the stream buffer.

  Private Attributes

std::string command_
The command used to start the process.
streambuf_type buf_
The stream buffer.

  Static Private Attributes

static const pmode pstdin = std::ios_base::out
Write to stdin.
static const pmode pstdout = std::ios_base::in
Read from stdout.
static const pmode pstderr = std::ios_base::app
Read from stderr.
static const pmode newpg = std::ios_base::trunc
Create a new process group for the child process.

Detailed Description

  template<typename CharT, typename Traits = std::char_traits<CharT>>
class redi::basic_rpstream< CharT, Traits >" Class template for Restricted PStreams.

Writing to an rpstream opened with pmode pstdin writes to the standard input of the command. It is not possible to read directly from an rpstream object, to use an rpstream as in istream you must call either basic_rpstream::out() or basic_rpstream::err(). This is to prevent accidental reads from the wrong input source. If the rpstream was not opened with pmode pstderr then the class cannot read the process' stderr, and basic_rpstream::err() will return an istream that reads from the process' stdout, and vice versa. Reading from an rpstream opened with pmode pstdout and/or pstderr reads the command's standard output and/or standard error. Any of the process' stdin, stdout or stderr that is not connected to the pstream (as specified by the pmode) will be the same as the process that created the pstream object, unless altered by the command itself.

Constructor & Destructor Documentation

  template<typename CharT , typename Traits = std::char_traits<CharT>> redi::basic_rpstream< CharT, Traits >::basic_rpstream (const std::string & cmd, pmode mode = pstdout|pstdin) [inline], [explicit]

Constructor that initialises the stream by starting a process. Initialises the stream buffer by calling do_open() with the supplied arguments.

Parameters:
    cmd a string containing a shell command.
    mode the I/O mode to use when opening the pipe.

See also:
    do_open(const std::string&, pmode)

  template<typename CharT , typename Traits = std::char_traits<CharT>> redi::basic_rpstream< CharT, Traits >::basic_rpstream (const std::string & file, const argv_type & argv, pmode mode = pstdout|pstdin) [inline]

Constructor that initialises the stream by starting a process. Initialises the stream buffer by calling do_open() with the supplied arguments.

Parameters:
    file a string containing the pathname of a program to execute.
    argv a vector of argument strings passed to the new program.
    mode the I/O mode to use when opening the pipe.

See also:
    do_open(const std::string&, const argv_type&, pmode)

  template<typename CharT , typename Traits = std::char_traits<CharT>> redi::basic_rpstream< CharT, Traits >::basic_rpstream (const argv_type & argv, pmode mode = pstdout|pstdin) [inline], [explicit]

Constructor that initialises the stream by starting a process. Initialises the stream buffer by calling do_open(argv[0],argv,mode)

Parameters:
    argv a vector of argument strings passed to the new program.
    mode the I/O mode to use when opening the pipe.

See also:
    do_open(const std::string&, const argv_type&, pmode)

References redi::pstreams::pstdin, and redi::pstreams::pstdout.

Member Function Documentation

  template<typename CharT , typename Traits = std::char_traits<CharT>> istream_type& redi::basic_rpstream< CharT, Traits >::err () [inline]

Obtain a reference to the istream that reads the process' stderr.

Returns:
    *this

  template<typename CharT , typename Traits = std::char_traits<CharT>> void redi::basic_rpstream< CharT, Traits >::open (const std::string & cmd, pmode mode = pstdout|pstdin) [inline]

Start a process. Calls do_open( cmd , mode ).

Parameters:
    cmd a string containing a shell command.
    mode the I/O mode to use when opening the pipe.

See also:
    do_open(const std::string&, pmode)

  template<typename CharT , typename Traits = std::char_traits<CharT>> void redi::basic_rpstream< CharT, Traits >::open (const std::string & file, const argv_type & argv, pmode mode = pstdout|pstdin) [inline]

Start a process. Calls do_open( file , argv , mode ).

Parameters:
    file a string containing the pathname of a program to execute.
    argv a vector of argument strings passed to the new program.
    mode the I/O mode to use when opening the pipe.

See also:
    do_open(const std::string&, const argv_type&, pmode)

  template<typename CharT , typename Traits = std::char_traits<CharT>> istream_type& redi::basic_rpstream< CharT, Traits >::out () [inline]

Obtain a reference to the istream that reads the process' stdout.

Returns:
    *this

Author

Generated automatically by Doxygen for PStreams from the source code.